﻿function scrollToSmooth(y, duration) {
    const startingY = window.pageYOffset;
    const startTime =
        'now' in window.performance ? performance.now() : new Date().getTime();

    function scroll() {
        const currentTime =
            'now' in window.performance
                ? performance.now()
                : new Date().getTime();
        const timeElapsed = currentTime - startTime;
        const run = easeInOutQuad(
            timeElapsed,
            startingY,
            y - startingY,
            duration
        );
        window.scrollTo(0, run);
        if (timeElapsed < duration) {
            requestAnimationFrame(scroll);
        }
    }

    function easeInOutQuad(t, b, c, d) {
        t /= d / 2;
        if (t < 1) return (c / 2) * t * t + b;
        t--;
        return (-c / 2) * (t * (t - 2) - 1) + b;
    }

    scroll();

    window.dispatchEvent(
        new WheelEvent('mousewheel', { bubbles: true, deltaY: -600 })
    );
}

scrollToSmooth(document.body.scrollHeight, 500);

var hV = setInterval(function() {
    //console.log("document.body.scrollHeight:" + document.body.scrollHeight + "\r\n" + lastScrollHeight);
    let scrollHeight =
        document.documentElement.scrollHeight || document.body.scrollHeight;
    let windowHeight =
        document.documentElement.clientHeight || document.body.clientHeight;
    let scrollTop =
        document.documentElement.scrollTop || document.body.scrollTop;
    var scrollBottom = scrollHeight - windowHeight - scrollTop;
    if (scrollBottom > 0) scrollToSmooth(document.body.scrollHeight, 500);
    else {
        clearInterval(hV);
        window.postMessage({
            command: 'finish_gather_current_html',
            doneid: window.doneid,
            html: document.body.innerHTML,
        });
    }
}, 1000);
