﻿function scrollToSmooth(y, duration) {
    const startingY = window.pageYOffset;
    const startTime =
        'now' in window.performance ? performance.now() : new Date().getTime();
    function scroll() {
        const currentTime =
            'now' in window.performance
                ? performance.now()
                : new Date().getTime();
        const timeElapsed = currentTime - startTime;
        const run = easeInOutQuad(
            timeElapsed,
            startingY,
            y - startingY,
            duration
        );
        window.scrollTo(0, run);
        if (timeElapsed < duration) requestAnimationFrame(scroll);
    }
    function easeInOutQuad(t, b, c, d) {
        t /= d / 2;
        if (t < 1) return (c / 2) * t * t + b;
        t--;
        return (-c / 2) * (t * (t - 2) - 1) + b;
    }
    scroll();
    window.dispatchEvent(
        new WheelEvent('mousewheel', { bubbles: true, deltaY: -600 })
    );
}
function starJob() {
    let scrollHeight =
        document.documentElement.scrollHeight || document.body.scrollHeight;
    let windowHeight =
        document.documentElement.clientHeight || document.body.clientHeight;
    let scrollTop =
        document.documentElement.scrollTop || document.body.scrollTop;
    let scrollBottom = scrollHeight - windowHeight - scrollTop;
    if (scrollBottom > 0) {
        scrollToSmooth(document.body.scrollHeight, 500);
        setTimeout(() => {
            starJob();
        }, 1500);
    } else {
        let urls = [];
        let path = location.origin + location.pathname + location.search;
        $("div[class*='templateList-module_shopItem']").each(function() {
            let params = null;
            try {
                params = JSON.parse(
                    $(this)
                        .find('.relative:first')
                        .attr('data-search-bury-info')
                );
            } catch (e) {}
            urls.push({
                url:
                    path + '#/theme_detail/' + params
                        ? params.shop_id + '/' + params.goods_id
                        : '',
                image: $(this)
                    .find('.image-hold-wrapper')
                    .find('img')
                    .attr('src'),
                text: $(this)
                    .find('.word-break.ellipsis-two')
                    .text(),
                price: $(this)
                    .find('.text-price')
                    .text(),
            });
        });
        window.postMessage({
            command: 'finish_gather_current_html',
            doneid: window.doneid,
            exts: {
                isArray: true,
                arr: urls,
                delay: 5000,
            },
        });
    }
}
setTimeout(() => {
    starJob();
}, 2000);
