﻿// 产品开发爬虫
var ProductDeveloper = function() {
    var _ = this;
    _.waiting = 1000;
    _.params = {};
    _.result = [];

    _.init = function() {};

    // 开始
    _.startUrls = function(tabid, urls, progressCallback, callback) {
        _.result = [];

        _.startNext(tabid, urls, 0, progressCallback, function(e) {
            callback(_.result);
        });
    };

    // 执行下一个
    _.startNext = function(tabid, urls, i, progressCallback, callback) {
        _.convertHTMLToList(tabid, urls[i], function(e) {
            _.result.push({
                url: urls[i],
                items: e.items,
            });

            progressCallback({
                index: i + 1,
                items: e.items,
            });

            if (urls[i + 1]) {
                _.startNext(tabid, urls, i + 1, progressCallback, callback);
            } else {
                callback();
            }
        });
    };

    // 采集页面相关内容并传到旺销王服务器
    _.convertHTMLToList = function(tabid, url, callback) {
        chrome.tabs.update(
            tabid,
            {
                url: url,
            },
            function() {
                setTimeout(function() {
                    var pageLoaded = false;
                    wxwUtil.watingFor(
                        function() {
                            //console.log("start 1.0");
                            chrome.tabs.executeScript(
                                tabid,
                                {
                                    code: `(function(){
                                                var hIv = 0;
                                                var h = 0;
                                                var lastHeight = 0;
                                                hIv = setInterval(function () {
                                                    if (document.body.scrollHeight != lastHeight) {
                                                        $("html,body")
                                                        .stop(true)
                                                        .animate(
                                                            { scrollTop: document.body.scrollHeight },
                                                            document.body.scrollHeight -
                                                            document.body.scrollTop -
                                                            $(window).height(),
                                                            function () {
                                                                clearTimeout(h);
                                                                clearInterval(hIv);

                                                                h = setTimeout(function () {
                                                                    $(document).scrollTop(0);
                                                                    window.W_read_finished = true;
                                                                }, 100);
                                                            }
                                                        );
                                                        lastHeight = document.body.scrollHeight;
                                                    }
                                                }, 1000);
                                            })()`,
                                    runAt: 'document_end',
                                },
                                function() {
                                    //console.log("start 2.0");
                                    clearInterval(_.h);
                                    var startTime = new Date().getTime();

                                    _.h = setInterval(function() {
                                        chrome.tabs.executeScript(
                                            tabid,
                                            {
                                                code:
                                                    '(function(){return window.W_read_finished;})()',
                                                runAt: 'document_end',
                                            },
                                            function(resultsArray) {
                                                if (
                                                    new Date().getTime() -
                                                        startTime >
                                                        20000 || // 20秒强制结束
                                                    (resultsArray &&
                                                        resultsArray[0])
                                                ) {
                                                    clearInterval(_.h);
                                                    chrome.runtime.sendMessage(
                                                        {
                                                            act:
                                                                'fetchToGatherBox',
                                                            command:
                                                                'favorite_all',
                                                            message: getI18n(
                                                                '正在收藏该页的产品..'
                                                            ),
                                                            params: _.params,
                                                            tabid,
                                                        },
                                                        function(e) {
                                                            console.log(e);
                                                            callback(e);
                                                        }
                                                    );
                                                }
                                            }
                                        );
                                    }, _.waiting);
                                }
                            );
                        },
                        function() {
                            //console.log("check 1.0")
                            try {
                                chrome.tabs.executeScript(
                                    tabid,
                                    {
                                        code:
                                            '(function(){return window.wxwUtil != null;})()',
                                        runAt: 'document_end',
                                    },
                                    function(resultsArray) {
                                        pageLoaded =
                                            resultsArray != null &&
                                            resultsArray.length > 0 &&
                                            resultsArray[0] == true;
                                    }
                                );
                            } catch (e) {}

                            return pageLoaded;
                        }
                    );
                }, 1000);
            }
        );
    };
};

window.wxwProductDev = new ProductDeveloper();
