﻿////const { debug } = require("webpack");

var background = function() {
    var _ = this;

    //_.users[domainItem.id] = {
    //    uid: ckData.uid,
    //    staffid: ckData.staffid,
    //    token: ckData.token,
    //};
    _.users = {}; // domainKey : { uid : 1 , staffid : "" }
    _.clients = {}; // domainKey : client object
    _.GATHER_REGEXS = null;
    _.staffid = ''; // 员工id
    _.roles = {};
    _.gatherFromPages = {};
    _.MEMORYS = {}; // 临时内存数据
    _.PC_CLIENT_HOST = 'http://localhost:40897';
    _.windowId = '';
    _.pageRequestBody = [];
    _.pageRequestHeaders = [];
    _.responseBodyUrls = [
        // 'https://detail.tmall.com/item.htm',
        // 'https://item.taobao.com/item.htm',
    ];

    _.GetGatherRegexItem = function(url) {
        if (!_.GATHER_REGEXS) return null;

        for (var key in _.GATHER_REGEXS) {
            if (url.match(key)) {
                return _.GATHER_REGEXS[key];
            }
        }

        return null;
    };

    _.init = function() {
        for (var key in _.clients) {
            _.clients[key].close();
        }
        _.clients = {};

        wxwUtil.domains = [];

        let url = localStorage.getItem('AloneUrl');
        if (url) {
            url = url.replaceAll('"', '');
            if (url && !url.includes('https://') && !url.includes('http://'))
                url = 'https://' + url;
            let arr = url.split('//');
            if (arr.length > 1) {
                let items = arr[1].split('.');
                let id = items.shift();
                wxwUtil.domains = [
                    {
                        id,
                        ws: `wss://${id + '-ws-chrome'}.${items.join('.')}`,
                        api: `${arr[0]}//${id + '-api'}.${items.join('.')}`,
                        ui: url,
                    },
                ];
            } else
                wxwUtil.domains = JSON.parse(JSON.stringify(wxwUtil.DOMAINS));
        } else wxwUtil.domains = JSON.parse(JSON.stringify(wxwUtil.DOMAINS));

        // 监听 tmall ResponseBody
        chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
            if (_.responseBodyUrls.find(el => tab.url.includes(el))) {
                let version = '1.3';
                chrome.debugger.attach(
                    {
                        tabId,
                    },
                    version,
                    onAttach.bind(null, tabId)
                );
                function onAttach(tabId) {
                    if (chrome.runtime.lastError) {
                        return;
                    }
                    chrome.debugger.sendCommand(
                        {
                            tabId,
                        },
                        'Network.enable'
                    );
                    chrome.debugger.onEvent.addListener(allEventHandler);
                }
                function allEventHandler(debuggeeId, message, params) {
                    if (tabId !== debuggeeId.tabId) {
                        return;
                    }
                    if (message === 'Network.responseReceived') {
                        let apiUrl = params
                            ? params.response
                                ? params.response.url
                                : ''
                            : '';
                        if (
                            apiUrl.includes(
                                'mtop.taobao.pcdetail.data.get/1.0/'
                            )
                        ) {
                            chrome.debugger.sendCommand(
                                {
                                    tabId: debuggeeId.tabId,
                                },
                                'Network.getResponseBody',
                                {
                                    requestId: params.requestId,
                                },
                                function(response) {
                                    console.log('response======>', response);
                                    _.pageRequestBody.push({
                                        body: response.body,
                                        url: tab.url,
                                    });
                                }
                            );
                        }
                    }
                    setTimeout(() => {
                        chrome.debugger.detach(debuggeeId);
                    }, 1000);
                }
            }
        });

        chrome.webRequest.onSendHeaders.addListener(
            function(details) {
                details.requestHeaders.some(function(header) {
                    if (header.name == 'Cookie') {
                        console.log('New Cookie value:' + header.value);
                        return true;
                    }
                    return false;
                });
            },
            { urls: ['<all_urls>'] },
            ['requestHeaders']
        );

        chrome.webRequest.onBeforeSendHeaders.addListener(
            function(details) {
                const { tabId, url, requestHeaders } = details;

                //if (url.includes("mtop.taobao.pcdetail.data.get") ||
                //    url.includes("wxwerp.com")) {

                //    // 获取请求头信息
                //    var headers = details.requestHeaders;

                //    debugger;

                //    // 遍历请求头

                //    for (var i = 0; i < headers.length; i++) {
                //        var header = headers[i];

                //        // 判断是否为 Cookie 头
                //        if (header.name.toLowerCase() === 'cookie') {
                //            var cookies = header.value;

                //            debugger;

                //            // 在这里可以处理 cookies
                //            console.log('Cookies:', cookies);
                //        }
                //    }

                //}

                var regexItem = _.GetGatherRegexItem(url);

                if (regexItem == null) return;
                if (!requestHeaders || !requestHeaders.length) return;

                for (var j = 0; j < regexItem.injects.length; j++) {
                    for (
                        var i = 0;
                        i < regexItem.injects[j].regexs.length;
                        i++
                    ) {
                        if (url.includes(regexItem.injects[j].regexs[i])) {
                            //debugger;
                            var URL_KEYWORDS =
                                regexItem.injects[j].headers || [];

                            for (var k = 0; k < URL_KEYWORDS.length; k++) {
                                if (url.includes(URL_KEYWORDS[k])) {
                                    //debugger;
                                    const _headers = {};
                                    $.each(requestHeaders, function(i, j) {
                                        _headers[j.name] = j.value;

                                        if (i + 1 === requestHeaders.length) {
                                            for (
                                                var k = 0;
                                                k < URL_KEYWORDS.length;
                                                k++
                                            ) {
                                                if (
                                                    url.indexOf(
                                                        URL_KEYWORDS[k]
                                                    ) > -1
                                                ) {
                                                    //debugger;
                                                    // 仅存放最后1000条数据
                                                    _.pageRequestHeaders.push({
                                                        headers: _headers,
                                                        url: url,
                                                    });

                                                    var maxArrLength = 100;
                                                    if (
                                                        _.pageRequestHeaders
                                                            .length >
                                                        maxArrLength
                                                    ) {
                                                        _.pageRequestHeaders.splice(
                                                            0,
                                                            _.pageRequestHeaders
                                                                .length -
                                                                maxArrLength
                                                        );
                                                    }

                                                    console.log(
                                                        'headers:' +
                                                            url +
                                                            '\r\n' +
                                                            JSON.stringify(
                                                                _.pageRequestHeaders
                                                            )
                                                    );

                                                    // 移除超过1000条数据
                                                    //_.pageRequestHeaders

                                                    //_.pageRequestHeaders[
                                                    //    URL_KEYWORDS[k]
                                                    //] = {
                                                    //    headers: _headers,
                                                    //    url: url,
                                                    //};
                                                }
                                            }
                                        }
                                    });
                                }
                            }
                        }
                    }
                }
            },
            //    {
            //        urls: ['<all_urls>'],
            //        types: ["main_frame", "sub_frame", "xmlhttprequest","requestHeaders"],
            //    },
            //    ['requestHeaders']
            //);
            { urls: ['<all_urls>'] },
            ['requestHeaders', 'blocking']
        );

        chrome.runtime.onMessage.addListener(function(
            message,
            sender,
            response
        ) {
            if (_[message.act]) {
                _[message.act](message, response, sender);
                return true;
            }
        });

        var setCookie = function() {
            let domains = wxwUtil.domains;
            for (var i = 0; i < domains.length; i++) {
                var host = domains[i].ui;
                var client = _.clients[domains[i].id];

                chrome.cookies.set({
                    url: host,
                    name: 'installed_chrome_extention',
                    value: JSON.stringify({
                        last: new Date().getTime().toString(),
                        clientid: client != null ? client.clientid : '',
                        ver: chrome.app.getDetails().version,
                    }),
                    path: '/',
                });
            }
        };

        // 有变化的时候设置
        var oldIds = {};
        setInterval(function() {
            for (var key in _.clients) {
                var id = oldIds[key];
                var client = _.clients[key];

                if (client == null) {
                    console.log(_.clients);
                }

                if (client.clientid != id) {
                    setCookie();
                    oldIds[key] = client.clientid;
                }
            }
        }, 1000);

        for (var i = 0; i < wxwUtil.domains.length; i++) {
            _.updateLoginedStatus(wxwUtil.domains[i]);
        }

        _.createMenus();

        return this;
    };

    _.GetPurchaseInfo = function(data, response) {
        $.ajax({
            url: 'https://localhost:44330/order/purchase/get_info',
            //url: _.getStatus().domain.api + '/order/purchase/get_info',
            contentType: 'application/json',
            headers: {
                Authorization: data.data.token,
            },
            data: JSON.stringify({
                url: data.data.url,
            }),
            type: 'post',
            success: function(e) {
                if (!e.success) {
                    response(e);
                    return;
                }
                localStorage.setItem('AlipayInfo', JSON.stringify(e.alipay));
                response(e);
            },
            error: function(e) {
                response({ success: false });
            },
        });
    };

    _.SetPayDone = function(data, response) {
        $.ajax({
            url: 'https://localhost:44330/order/purchase/pay_done',
            //url: _.getStatus().domain.api + '/order/purchase/pay_done',
            contentType: 'application/json',
            headers: {
                Authorization: data.data.token,
            },
            data: JSON.stringify({
                url: data.data.url,
            }),
            type: 'post',
            success: function(e) {
                response(e);
            },
            error: function(e) {
                response({ success: false });
            },
        });
    };

    _.GetPurchaseMd5 = function(data, response) {
        data = data.data;
        var json = localStorage.getItem('purchase/sides');

        if (!json) {
            response({ success: false });
        }

        var items = JSON.parse(json);

        for (var id in items) {
            var urls = [data.url, data.referrer];
            for (var i = 0; i < urls.length; i++) {
                var url = urls[i];

                if (
                    items[id].regex == url ||
                    new RegExp(items[id].regex).test(url)
                ) {
                    // 请求服务器索取边栏数据内容
                    var ajaxPost = {
                        url: items[id].host + '/packaging/purchase/get_side',
                        headers: {
                            'Content-Type': 'application/json',
                        },
                        type: 'post',
                        data: JSON.stringify({ mid: id }),
                        success: function(e) {
                            if (!e.success) {
                                response(e);
                                return;
                            }

                            response({ success: true, data: e });
                        },
                        error: function(e) {
                            response({ success: false });
                        },
                    };

                    $.ajax(ajaxPost);
                    return;
                }
            }
        }

        response({
            success: false,
            skip: true,
            message: 'no found any purcahase md5',
        });
    };

    _.SavePurchaseMd5 = function(data, response) {
        if (data.data) {
            var json = localStorage.getItem('purchase/sides');
            if (!json) items = {};
            else {
                items = JSON.parse(json);
                // 将时间太久的给与删除掉
                var newItems = {};
                for (var id in items) {
                    if (items[id].date + 60000 > new Date().getTime()) {
                        newItems[id] = items[id]; // 仅保留为未超时的部分
                    }
                }
                items = newItems;
            }
            items[data.data.id] = {
                host: data.data.host,
                regex: data.data.showSideRegex,
                date: new Date().getTime(),
            };
            localStorage.setItem('purchase/sides', JSON.stringify(items));
        } else localStorage.removeItem('purchase/sides');

        response({ success: true });
    };

    _.GetLocalStorage = function(data, response) {
        var datas = {};
        for (var i = 0; i < data.keys.length; i++) {
            datas[data.keys[i]] = localStorage.getItem(data.keys[i]);
        }
        response({ success: true, config: datas });
    };

    _.SetLocalStorage = function(data, response) {
        localStorage.setItem(data.key, JSON.stringify(data.value));
        response({ success: true });
    };

    _.getResponseBody = function(e, response) {
        const data = _.pageRequestBody.find(item => {
            const target = e.url.split('?');
            const origin = item.url.split('?');
            if (origin.length > 1) {
                const targetItems = target[1].split('&');
                const originItems = origin[1].split('&');
                for (let i = 0; i < originItems.length; i++) {
                    const targetItem = targetItems.find(
                        el => el == originItems[i]
                    );
                    if (!targetItem) return false;
                }
                return true;
            } else return origin == target;
        });
        response(data ? data.body : '');
    };

    _.quit = function() {
        _.users = {};

        for (var key in _.clients) {
            _.clients[key].close();
        }

        for (var i = 0; i < wxwUtil.domains.length; i++) {
            // 强制删除 cookie
            chrome.cookies.set({
                url: host,
                name: 'wxw30',
                value: '',
                path: '/',
            });
        }
    };

    _.debugReconnect = function() {
        _.clients['v3'].connect(function() {});
    };

    _.getHostByKey = function(id) {
        var domain = null;

        for (var i = 0; i < wxwUtil.domains.length; i++) {
            if (wxwUtil.domains[i].id == id) {
                domain = wxwUtil.domains[i];
                break;
            }
        }

        return domain;
    };

    _.getStatus = function() {
        var domain = null;

        for (var id in _.users) {
            if (_.users[id].uid != 0) {
                for (var i = 0; i < wxwUtil.domains.length; i++) {
                    if (wxwUtil.domains[i].id == id) {
                        domain = wxwUtil.domains[i];
                        break;
                    }
                }

                if (domain) {
                    return {
                        user: _.users[id],
                        domain: domain,
                    };
                }
            }
        }

        for (var i = 0; i < wxwUtil.domains.length; i++) {
            if (wxwUtil.domains[i].id == 'v3') domain = wxwUtil.domains[i];
        }

        return {
            user: null,
            domain: domain,
        };
    };

    _.getLoginedUid = function(domainItem, done) {
        var uiHost = domainItem.ui;

        //if (domainItem.id == "local") {
        //    debugger;
        //}

        chrome.cookies.get(
            {
                url: uiHost,
                name: 'wxw30',
            },
            function(cookie) {
                try {
                    if (cookie != null) {
                        var ckData = {
                            uid: 0,
                            token: '',
                        };

                        var keys = ['uid', 'token', 'staffid'];
                        var cookieVals = cookie.value.split('&');

                        for (var i = 0; i < cookieVals.length; i++) {
                            for (var j = 0; j < keys.length; j++) {
                                if (cookieVals[i].indexOf(keys[j] + '=') >= 0) {
                                    var val = cookieVals[i].replace(
                                        keys[j] + '=',
                                        ''
                                    );
                                    ckData[keys[j]] = val;
                                }
                            }
                        }

                        _.users[domainItem.id] = {
                            uid: ckData.uid,
                            staffid: ckData.staffid,
                            token: ckData.token,
                        };

                        if (
                            domainItem.id == 'local' &&
                            _.users[domainItem.id].uid > 0
                        )
                            wxwUtil.local = true;

                        done(ckData.uid);
                        return;
                    }
                } catch (e) {
                    debugger;
                }

                done(0);
            }
        );
    };

    _.getHost = function(url) {
        var arr = url.split('/');
        var host = arr.find(a => a != '' && !a.includes(':'));
        return host;
    };

    _.getCookiesStr = function(cookies) {
        var arr = [];

        for (var i = 0; i < cookies.length; i++) {
            arr.push(cookies[i].name + '=' + cookies[i].value);
        }

        return arr.join(';');
    };

    _.getCookies = function(url, done) {
        chrome.cookies.getAll(
            {
                url: 'https://' + _.getHost(url),
            },
            function(cookie) {
                done(cookie);
            }
        );
    };

    _.isPcAppRunning = function(done) {
        var ajaxPost = {
            timeout: 3000,
            url: _.PC_CLIENT_HOST + '/check',
            type: 'get',
            success: function(html) {
                done({ success: true, message: 'ok' });
            },
            error: function(e) {
                return done({
                    success: false,
                    message: 'NO-PC-CLIENT',
                });
            },
        };

        $.ajax(ajaxPost);
    };

    // 通过pc的客户端进行采集
    _.gatherFromPcApp = function(url, done, e) {
        if (!e) e = { method: 'get' };

        _.getCookies(url, function(cookie) {
            var post = {
                headers: e.header ? e.header : {},
                url: url,
                method: e.method,
                body: e.post,
                file: e.file,
            };

            if (!post.headers.Cookie)
                post.headers.Cookie = _.getCookiesStr(cookie);

            console.log('cc1' + _.getCookiesStr(cookie));

            if (_.getCookiesStr(cookie).match(/(?:^|;)\s*x5sec=([^;]*)/)) {
                console.log(
                    'cc3' +
                        post.headers.cookie +
                        _.getCookiesStr(cookie).match(
                            /(?:^|;)\s*x5sec=([^;]*)/
                        )[0]
                );
                post.headers.Cookie =
                    post.headers.Cookie +
                    _.getCookiesStr(cookie).match(/(?:^|;)\s*x5sec=([^;]*)/)[0];
            }

            if (!post.headers.referer) post.headers.referer = url;

            if (!post.headers.encoding && e.encoding)
                post.headers.encoding = e.encoding;

            // 先试探是否已启动客户端？？
            _.isPcAppRunning(function(eRunning) {
                if (!eRunning.success) {
                    return done({
                        success: false,
                        message: eRunning.message,
                    });
                }

                console.log('gatherFromPcApp start:' + url);
                console.log('gatherFromPcApp post:' + JSON.stringify(post));

                var ajaxPost = {
                    timeout: 60000, // 1分钟超时
                    url: _.PC_CLIENT_HOST + '/',
                    type: 'post',
                    data: { json: JSON.stringify(post) },
                    success: function(html) {
                        if (html == null) html = '';

                        console.log(
                            'gatherFromPcApp html:' + JSON.stringify(html)
                        );

                        return done({
                            success: true,
                            message: 'ok',
                            html: html,
                        });
                    },
                    error: function(e) {
                        console.log('gatherFromPcApp failed:' + e.responseText);

                        return done({
                            success: true,
                            message: 'failed',
                            html: e.responseText,
                        });
                    },
                };

                $.ajax(ajaxPost);
            });
        });
    };

    // var delayFinish = {}; // {url : {arr:[]}}

    var gatherFromOpenPageCallback = {};

    // 通过web打开方式采集
    _.gatherFromOpenPage = function(url, done, e) {
        var originUrl = url;

        // 打开窗口后，并要求UI发送消息给BG，获得HTML后执行 done
        var gatherid = 'wxwgatherid_' + new Date().getTime();

        if (!e) e = {};

        if (url.includes('?')) url += '&gatherid=' + gatherid;
        else url += '?gatherid=' + gatherid;

        var tabid = 0;
        if (_.windowId) {
            chrome.windows.get(_.windowId, function(window) {
                const params = {
                    url: url,
                    //active: true,
                    active: false,
                };

                if (url.includes('17qcc.') || url.includes('yangkeduo.')) {
                    params.active = true;
                }

                if (chrome.runtime.lastError || !window) {
                    _.windowId = '';
                } else {
                    params.windowId = _.windowId;
                }

                chrome.tabs.query(
                    { active: true, currentWindow: false },
                    function(tabs) {
                        const item = tabs.find(el => el.active);
                        params.index = item ? item.index + 1 : 0;

                        chrome.tabs.create(params, function(tab) {
                            if (tab) {
                                tabid = tab.id;
                                gatherFromOpenPageCallback[originUrl].tabid =
                                    tab.id;
                            }
                        });
                    }
                );
            });
        } else {
            chrome.windows.getCurrent(function(window) {
                _.windowId = window.id;

                chrome.tabs.create(
                    {
                        url: url,
                        active: false, // 第一次要打开窗口
                        windowId: _.windowId,
                    },
                    function(tab) {
                        tabid = tab.id;
                        gatherFromOpenPageCallback[originUrl].tabid = tab.id;
                    }
                );
            });
        }

        gatherFromOpenPageCallback[originUrl] = {
            done: done,
            e: e,
            enabled: false,
        };

        wxwUtil.watingFor(
            function() {
                var uiReady = false;

                wxwUtil.watingFor(
                    function() {
                        _.gatherCurrentHtml({
                            data: { tabid, url, originUrl },
                        });
                    },
                    function() {
                        try {
                            chrome.tabs.sendMessage(
                                tabid,
                                {
                                    act: 'testUi',
                                },
                                function(e) {
                                    if (e && e.ok) uiReady = e.ok;
                                }
                            );
                        } catch {}

                        return uiReady;
                    },
                    { sleep: 100, timeout: 30000 * 5 }
                );
            },
            function() {
                return !!tabid;
            },
            { sleep: 100, timeout: 60000 * 5 }
        );
    };

    _.gatherUpdateTab = function(res) {
        localStorage.setItem('SlideVerifyInfo', JSON.stringify(res.data));
        chrome.tabs.update(res.data.tabid, { active: true });
        chrome.tabs.sendMessage(res.data.tabid, {
            act: 'dragandDrop', // 直接请求ui抓取当前的 document.bodu.innerHTML
            id: 'nc_1_n1z',
            clientX: 100,
            clientY: 0,
            distance: 1000,
        });
    };

    _.getQueryTabs = function(res) {
        chrome.tabs.query({}, function(tabs) {
            const tab = tabs.find(el => el.url == res.data.url);
            if (tab) {
                res.data.tabid = tab.id;
                _.gatherCurrentHtml(res);
            }
        });
    };

    _.gatherCurrentHtml = function(res) {
        const { tabid } = res.data;
        chrome.tabs.sendMessage(
            tabid,
            {
                act: 'tryAutoSlide', // 直接请求ui抓取当前的 document.bodu.innerHTML
                data: res.data,
            },
            function(data) {
                _.gatherHtmlDone({ data });
            }
        );
    };

    _.gatherHtmlDone = function(res) {
        let e = res.data;
        const from = e ? gatherFromOpenPageCallback[e.originUrl] : null;
        // 通过websocket 回传回去
        if (!e) e = {};
        if (!e.html) e.html = '';
        if (!e.exts) e.exts = {};
        if (!from || (from && from.enabled)) return;

        // 需要订阅的header加进来
        if (_.pageRequestHeaders) {
            try {
                if (e.html == '') e.html = '{}';

                var x = JSON.parse(e.html); // parse 可能出现错误
                x.pageRequestHeaders = _.pageRequestHeaders;

                e.html = JSON.stringify(x);
            } catch (e) {
                console.log('gatherFromOpenPage 3.3.1 ' + JSON.stringify(e));
            }
        }

        localStorage.removeItem('SlideVerifyInfo');
        chrome.tabs.remove(e.tabid);

        return from.done({
            success: true,
            message: 'ok',
            html: e.html,
        });
    };

    // 采集
    _.getGatherHtml = function(url, done, e) {
        var type = 'get';
        var post = {};

        //if (url.includes('pifa')) {
        //    console.log('pifa 1.0');
        //}

        if (e) {
            if (e.method) type = e.method;
            if (e.post) post = e.post;
        }

        //if (url.includes('pifa')) {
        //    console.log('pifa 2.0');
        //}

        if (e.header) {
            e.header = JSON.parse(e.header);

            if (e.header['frompage'] == 'true') {
                delete e.header.frompage;
                delete e.header.sleep;

                _.gatherFromOpenPage(url, done, e);
                return;
            }

            if (e.header['fromapp'] == 'true') {
                delete e.header.fromapp;
                delete e.header.sleep;

                //if (url.includes('pifa')) {
                //    console.log('pifa 3.0');
                //}
                _.gatherFromPcApp(url, done, e);
                return;
            }
        }

        //if (url.includes('pifa')) {
        //    console.log('pifa 4.0');
        //}

        if (url == 'LOCALSTORAGE') {
            var pn = JSON.parse(e.post);
            // pn : {keys : ["key1", "key2"] }

            // 返回值: {key1:"xx", key2:"xxxyy"}
            _.GetLocalStorage({ keys: pn.keys }, function(e) {
                return done({
                    success: true,
                    message: 'ok',
                    html: e.config,
                });
            });
            return;
        }

        if (url == 'COOKIE') {
            var pn = JSON.parse(e.post);

            if (!pn.name) {
                chrome.cookies.getAll(
                    {
                        url: pn.url,
                    },
                    function(cookie) {
                        return done({
                            success: true,
                            message: 'ok',
                            html: cookie,
                        });
                    }
                );
            } else {
                chrome.cookies.get(pn, function(cookie) {
                    try {
                        if (cookie != null) {
                            return done({
                                success: true,
                                message: 'ok',
                                html: cookie.value,
                            });
                        }
                    } catch (e) {}

                    return done('NO FOUND COOKIE');
                });
            }

            return;
        }

        if (!e.header) e.header = {};

        var ajaxPost = {
            url: url,
            type: type,
            data: post,
            headers: e.header ? e.header : {},
            success: function(html) {
                if (html == null) html = '';

                return done({ success: true, message: 'ok', html: html });
            },
            error: function(e) {
                return done({
                    success: true,
                    message: 'failed',
                    html: e.responseText,
                });
            },
        };

        $.ajax(ajaxPost);
    };

    _.onClientMessage = function(client, command, params) {
        //if (params.url &&
        //    params.url.includes("pifa"))
        //    debugger;

        // console.log("onClientMessage:" + JSON.stringify(params));

        // 收到下载指令
        if (command == 'download') {
            if (params.transferUrl) {
                wxwUtil.urlToBase64(params.transferUrl).then(res => {
                    var post = {
                        file: params.file,
                        url: params.url,
                        post: params.post,
                        header: params.header,
                        encoding: params.encoding,
                        success: true,
                        message: '',
                        html: '',
                        watingkey: params.watingkey,
                        version: wxwUtil.VERSION,
                        useApp: wxwUtil.useApp,
                    };
                    if (res.success) post.html = res.base64;
                    else post.success = false;
                    client.request('gather', post);
                });
            } else {
                _.getGatherHtml(
                    params.url,
                    function(result) {
                        // 将HTML送至服务器
                        var post = {
                            file: params.file,
                            url: params.url,
                            post: params.post,
                            header: params.header,
                            encoding: params.encoding,
                            success: result.success,
                            message: result.message,
                            html: result.html,
                            watingkey: params.watingkey,
                            version: wxwUtil.VERSION,
                            useApp: wxwUtil.useApp,
                        };

                        client.request('gather', post);
                    },
                    params
                );
            }
        }

        // 收到规则信息
        if (command == 'roles') {
            if (!_.GATHER_REGEXS_ITEMS)
                _.GATHER_REGEXS_ITEMS = {
                    h: 0,
                    items: {},
                };

            _.GATHER_REGEXS_ITEMS.items[client.domainItem.api] =
                params.GATHER_REGEXS;

            // 调试环境优先
            var prioritys = [
                'https://localhost:44330',
                'https://v3-test-api.wxwerp.com',
            ];

            clearTimeout(_.GATHER_REGEXS_ITEMS.h);

            _.GATHER_REGEXS_ITEMS.h = setTimeout(function() {
                for (var i = 0; i < prioritys.length; i++) {
                    if (
                        !_.GATHER_REGEXS &&
                        _.GATHER_REGEXS_ITEMS.items[prioritys[i]]
                    )
                        _.GATHER_REGEXS =
                            _.GATHER_REGEXS_ITEMS.items[prioritys[i]];
                }

                if (!_.GATHER_REGEXS) _.GATHER_REGEXS = params.GATHER_REGEXS;
            }, 1000);

            //_.GATHER_REGEXS = params.GATHER_REGEXS;

            // 注入优先级
            // 当本地连接成功的情况下优先采用 localhost
            console.log(client);
        }
    };

    _.getGatherRegex = function(message, response) {
        response({ success: true, GATHER_REGEXS: _.GATHER_REGEXS });
    };

    _.createClient = function(uid, domainItem) {
        if (_.clients[domainItem.id]) {
            _.clients[domainItem.id].disposed = true;
            _.clients[domainItem.id].close();
        }

        var client = new Client(domainItem);

        //console.log("create " + domainItem.id);
        console.log(client);
        console.log(domainItem);
        _.clients[domainItem.id] = client;
        client.Events.Message = function(command, params) {
            return _.onClientMessage(client, command, params);
        };
        client.init(uid);
        _.updateLoginedStatus(domainItem);
    };

    var repeatSetTimeoutH = {};
    // 不断更新已登录的账号
    var updateLoginedStatusTimes = 0;
    _.updateLoginedStatus = function(domainItem) {
        //console.log("updateLoginedStatus " + domainItem.id);
        _.getLoginedUid(domainItem, function(uid) {
            var changed = false;
            var client = _.clients[domainItem.id];

            if (client == null || client.uid != uid) {
                changed = true;

                chrome.storage.sync.set({
                    //uid: uid,
                    status: _.getStatus(),
                });
            }

            if (uid != 0) {
                // 一旦发生改变时，通知并重新登陆
                if (changed) {
                    console.log('createClient changed ' + domainItem.id);
                    _.createClient(uid, domainItem);
                }
            } else {
                if (client) {
                    client.close();
                    client = null;

                    //debugger;
                    console.log('delete ' + domainItem.id);
                    delete _.clients[domainItem.id];
                }
            }
        });

        if (!repeatSetTimeoutH[domainItem.id])
            repeatSetTimeoutH[domainItem.id] = 0;

        clearTimeout(repeatSetTimeoutH[domainItem.id]);

        var sleep = 1000;

        if (updateLoginedStatusTimes++ > 10) sleep = 10000;

        repeatSetTimeoutH[domainItem.id] = setTimeout(function() {
            _.updateLoginedStatus(domainItem);
        }, sleep);
    };

    _.createMenus = function() {
        if (window.getI18n) {
            //chrome.contextMenus.remove('mnuStartGather');
            //chrome.contextMenus.create({
            //    title: getI18n("收藏到旺销王"),
            //    id: "mnuStartGather",
            //    onclick: function (data, tabs) {
            //        var url = tabs[0].url;
            //        if (new GatherRegex(_.GATHER_REGEXS)
            //            .IsUrlInDetailRegex(url)) {
            //            _.fetchToGatherBox({
            //                command: "gather_from_current_page"
            //            }, function () {
            //            });
            //        }
            //        else {
            //            _.fetchToGatherBox({
            //                command: "favorite_all",
            //                message: getI18n("正在收藏该页的产品..")
            //            }, function () {
            //            });
            //        }
            //    }
            //});
        }
    };

    var delayGather = {};
    _.setDelayFinishGatherCurrentHtml = function(message, response) {
        var html = message.html;
        var exts = message.exts;

        if (!delayGather[message.url])
            delayGather[message.url] = { arr: [], h: 0 };

        for (var i = 0; i < message.exts.arr.length; i++) {
            delayGather[message.url].arr.push(message.exts.arr[i]);
        }

        var originUrl = message.url.split('&gatherid=')[0];

        if (!gatherFromOpenPageCallback[originUrl]) debugger;

        gatherFromOpenPageCallback[originUrl].enabled = true;

        clearTimeout(delayGather[message.url].h);
        delayGather[message.url].h = setTimeout(function() {
            gatherFromOpenPageCallback[originUrl].done({
                success: true,
                message: 'ok',
                html: JSON.stringify(delayGather[message.url].arr),
            });

            setTimeout(function() {
                chrome.tabs.remove(gatherFromOpenPageCallback[originUrl].tabid);
                gatherFromOpenPageCallback[originUrl] = null; // 清空内存
            }, 1000);
        }, message.exts.delay);
    };

    _.urlTransferBase64 = function(e, response) {
        wxwUtil.urlToBase64(e.url).then(res => {
            response(res);
        });
    };

    // 添加到采集箱
    _.fetchToGatherBox = function(message, response) {
        if (!message) message = {};

        response = response || function() {};

        var e = message;

        chrome.tabs.query({ active: true, currentWindow: true }, function(
            tabs
        ) {
            var tab = tabs[0]; //.find(el => el.active);

            if (e.tabid) {
                var item = tabs.find(el => el.id == e.tabid);
                if (item) tab = item;
            }

            var url = ''; //message.url;

            if (url == null || url == '') url = tab.url;

            // 判断该页面是否是支持的
            if (!_.GATHER_REGEXS) return;

            var found = false;

            for (var key in _.GATHER_REGEXS) {
                if (url.match(key)) {
                    found = true;
                }
            }

            if (!found) {
                response({
                    success: false,
                    message: getI18n('暂不支持采集本页面3'),
                });
                return;
            }

            _.lastTab = tab;
            var tabid = e ? e.tabid : 0;

            if (!tabid && tab) tabid = tab.id;

            var count = 0;
            for (var user in _.users) {
                count++;
            }

            if (count == 0) {
                response({
                    success: false,
                    message: getI18n('您当前未登录'),
                });
                return;
            }

            if (tab == null) {
                response({
                    success: false,
                    message: getI18n('找不到当前的浏览器标签页'),
                });
                return;
            }

            var haveConnected = false;
            for (var key in _.clients) {
                var client = _.clients[key];

                if (client.isConnected()) {
                    haveConnected = true;
                }
            }

            if (!haveConnected) {
                response({
                    success: false,
                    message: getI18n('未初始化连接，请重启插件再试'),
                });
                return;
            }

            if (!message.message) {
                message.message = getI18n('正在采集..');
            }

            _.showMessage(tabid, {
                success: true,
                message: message.message,
            });

            var groupName = localStorage.getItem('SpiderGroupName') || '';
            if (groupName) groupName = JSON.parse(groupName);

            var isPrivateGroup = localStorage.getItem('IsPrivateGroup');
            if (isPrivateGroup) isPrivateGroup = isPrivateGroup == 'true';

            // 采集当前整个HTML
            if (e.command == 'gather_from_current_page') {
                chrome.tabs.sendMessage(
                    tabid,
                    {
                        act: 'gatherCurrentHtml', // 直接请求ui抓取当前的 document.body.innerHTML
                    },
                    function(e) {
                        for (var key in _.clients) {
                            var client = _.clients[key];
                            var user = {};

                            if (_.users[key]) user = _.users[key];

                            console.log('url:' + url);

                            if (client.isConnected()) {
                                _.requestWxwServer(
                                    {
                                        url: url,
                                        html: e.html,
                                        version: wxwUtil.VERSION,
                                        act: 'collect_current_page',
                                        uid: user.uid,
                                        staffid: user.staffid,
                                        chrome: {
                                            clientid: client.clientid,
                                            ver: chrome.app.getDetails()
                                                .version,
                                            ignore_warning: true,
                                        },
                                        hostKey: key,
                                        groupName: groupName,
                                    },
                                    function(e) {
                                        _.showMessage(tabid, e);

                                        response(e);
                                    }
                                );
                            }
                        }
                    }
                );
                // 采集图像链接过来的
            } else if (e.command == 'gather_from_list_item') {
                for (var key in _.users) {
                    if (!_.users[key].uid) return;

                    var data = e;

                    data.act = 'add_favorite';
                    data.version = wxwUtil.VERSION;
                    data.uid = _.users[key].uid;
                    data.staff_id = _.users[key].staffid;
                    data.tabUrl = tab.url;
                    data.hostKey = key;
                    data.chrome = {
                        clientid: client.clientid,
                        ver: chrome.app.getDetails().version,
                        ignore_warning: true,
                    };
                    data.groupName = groupName;
                    data.isPrivateGroup = isPrivateGroup;

                    delete data.command;

                    _.requestWxwServer(data, function(e) {
                        _.showMessage(tabid, e);

                        response(e);
                    });
                }
            } else if (e.command == 'gather_from_current_item') {
                chrome.tabs.sendMessage(
                    tabid,
                    {
                        act: 'gatherCurrentHtml', // 直接请求ui抓取当前的 document.body.innerHTML
                    },
                    function(event) {
                        for (var key in _.users) {
                            if (!_.users[key].uid) return;

                            var data = e;

                            data.act = 'add_favorite';
                            data.version = wxwUtil.VERSION;
                            data.uid = _.users[key].uid;
                            data.staff_id = _.users[key].staffid;
                            data.tabUrl = tab.url;
                            data.url = tab.url;
                            data.html = event.html;
                            data.hostKey = key;
                            data.chrome = {
                                clientid: client.clientid,
                                ver: chrome.app.getDetails().version,
                                ignore_warning: true,
                            };
                            data.groupName = groupName;
                            data.isPrivateGroup = isPrivateGroup;

                            delete data.command;

                            _.requestWxwServer(data, function(e) {
                                _.showMessage(tabid, e);

                                response(e);
                            });
                        }
                    }
                );
            } else if (e.command == 'favorite_all') {
                chrome.tabs.sendMessage(
                    tabid,
                    {
                        act: 'gatherCurrentItems', // 直接请求ui抓取当前的 document.body.innerHTML
                    },
                    function(event) {
                        for (var key in _.clients) {
                            var client = _.clients[key];
                            var user = {};

                            if (_.users[key]) user = _.users[key];

                            console.log('url:' + url);

                            if (client.isConnected()) {
                                _.requestWxwServer(
                                    Object.assign(
                                        {
                                            url: tab.url,
                                            items: event.items,
                                            version: wxwUtil.VERSION,
                                            act: 'favorite_all',
                                            uid: user.uid,
                                            staffid: user.staffid,
                                            chrome: {
                                                clientid: client.clientid,
                                                ver: chrome.app.getDetails()
                                                    .version,
                                                ignore_warning: true,
                                            },
                                            hostKey: key,
                                            groupName: groupName,
                                            isPrivateGroup: isPrivateGroup,
                                        },
                                        e.params || {}
                                    ),
                                    function(res) {
                                        res.items = event.items;
                                        _.showMessage(tabid, res);
                                        response(res);
                                    }
                                );
                            }
                        }
                    }
                );
            }
        });
    };

    _.showMessage = function(tabid, result) {
        result.act = 'showMessage';
        chrome.tabs.sendMessage(tabid, result);
    };

    // 请求旺销王服务器
    _.requestWxwServer = function(data, response) {
        var api = '';

        if (data.hostKey) {
            var host = _.getHostByKey(data.hostKey);
            api = host.api;

            if (!host) response({});
        } else {
            api = _.getStatus().domain.api;
        }

        var url = '';
        var _data = JSON.stringify(data);

        if (data.isApi) {
            url = api + '/chrome/extention/' + data.url;
            _data = JSON.stringify(data.data);
        } else {
            url = api + '/chrome/extention/' + data.act;
        }

        $.ajax({
            url: url,
            data: _data,
            contentType: 'application/json',
            type: 'post',
            success: function(e) {
                response(e);
            },
            error: function(e) {
                response(e);
            },
        });
    };
};

window.wxwBG = new background().init();
