﻿(function startReact() {
    window.chromeI18n = {
        zh: {}, en: {}, pt: {}, th: {}, tl: {}, id: {}, es: {}, vi: {}, ms: {}, ja: {}, ko: {}, 'zh-TW': {}
    };

    if (chrome.storage) {
        chrome.storage.sync.get('language', function (res) {
            try {
                //console.log(res)
                if (res != null && res.language) {
                    wxwUtil.language = res.language;
                    return;
                }
            } catch (e) { }
        });
    }
    window.getI18n = function (text, key) {
        if (text && text[0] == "_") {
            text = text.substring(1);
        }

        text = text + '';
        let tVar = {};
        if (!key) key = wxwUtil.language;
        if (chromeI18n[key]) {
            if (text.indexOf('|') == -1) {
                let res = chromeI18n[key][text];
                if (res) {
                    return res;
                } else {
                    return text;
                }
            } else {
                let list = text.split('|');
                let rKey;
                rKey = list[0];
                let templateValueList = {};

                for (let i = list.length; i > 1; i--) {
                    if (new RegExp(/{[\d]+}/).test(list[i - 1])) {
                        let len = list[i - 1].match(/{[\d]+}/g).length;
                        let templateValue = [];
                        for (let j = 0; j < len; j++) {
                            if (Object.keys(templateValueList).length == 0) {
                                templateValue.push(list[i + j]);
                            } else {
                                templateValue.push(tVar[i + j]);
                            }
                        }

                        templateValueList[i - 1] = {};
                        templateValue.sort().forEach((el, index) => {
                            templateValueList[i - 1][index] = el;
                        });

                        tVar[i - 1] = chromeI18n[key][list[i - 1]];
                        if (!tVar[i - 1]) tVar[i - 1] = list[i - 1];
                        for (let j = 0; j < len; j++) {
                            tVar[i - 1] = tVar[i - 1].replace(
                                `{${j}}`,
                                templateValue[j]
                            );
                        }
                    } else {
                        tVar[i - 1] = list[i - 1];
                    }
                }

                let res = {};
                if (rKey.match(/{[\d]+}/g)) {
                    let len = rKey.match(/{[\d]+}/g).length;
                    for (let i = 0; i < len; i++) {
                        let v = Object.values(tVar);
                        res[i] = v[i];
                    }
                }
                let lastRes = '';

                lastRes = chromeI18n[key][rKey];
                if (!lastRes) lastRes = rKey;
                for (let j = 0; j < rKey.match(/{[\d]+}/g).length; j++) {
                    lastRes = lastRes.replace(`{${j}}`, res[j]);
                }

                return lastRes;
            }
        }
    };
})();
